import { ReactNode } from 'react';
type Props = {
    to: string;
    children?: ReactNode;
};
type PrefetchLinkContext = {
    loading: boolean;
    error?: Error;
    view?: ReactNode;
};
/**
 * Get the prefetch context. Use for render a preview view.
 * @group Hooks
 */
export declare function usePrefetch(): PrefetchLinkContext;
/**
 * Link support hover prefetch.
 * @param props
 * @group Components
 */
export default function PrefetchLink({ to, children, ...rest }: Props): JSX.Element;
export {};
